Index: demo/Makefile.am
===================================================================
--- demo/Makefile.am	(revision 1971)
+++ demo/Makefile.am	(revision 1979)
@@ -17,5 +17,5 @@
 	descriptor_map_demo \
 	coloring \
-	grid_graph_demo \
+	grid_ugraph_demo \
 	topology_demo \
 	simann_maxcut_demo
@@ -44,5 +44,5 @@
 graph_to_eps_demo_SOURCES = graph_to_eps_demo.cc
 
-grid_graph_demo_SOURCES = grid_graph_demo.cc
+grid_ugraph_demo_SOURCES = grid_ugraph_demo.cc
 
 graph_orientation_SOURCES = graph_orientation.cc
Index: demo/grid_ugraph_demo.cc
===================================================================
--- demo/grid_ugraph_demo.cc	(revision 1979)
+++ demo/grid_ugraph_demo.cc	(revision 1979)
@@ -0,0 +1,102 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#include <lemon/grid_ugraph.h>
+#include <lemon/graph_adaptor.h>
+#include <lemon/graph_to_eps.h>
+#include <lemon/bfs.h>
+#include <lemon/xy.h>
+
+#include <iostream>
+#include <fstream>
+
+///\ingroup demos
+///\file
+///\brief Labirinth example with grid ugraph.
+///
+///  Labirinth example with grid ugraph.
+///
+/// The input file is:
+///
+/// \include grid_ugraph_demo.in
+///
+/// The result:
+///
+/// \image html grid_ugraph_demo.png
+/// \image latex grid_ugraph_demo.eps "The labirinth" width=\textwidth
+///
+/// The source:
+///
+/// \include grid_ugraph_demo.cc
+
+using namespace lemon;
+using namespace std;
+
+int main() {
+  ifstream in("grid_ugraph_demo.in");
+  int width, height;
+  in >> width >> height;
+  int start_x, start_y;
+  in >> start_x >> start_y;
+  int stop_x, stop_y;
+  in >> stop_x >> stop_y;
+
+  GridUGraph ugraph(width, height);
+  GridUGraph::Node start = ugraph(start_x - 1, start_y - 1);
+  GridUGraph::Node stop = ugraph(stop_x - 1, stop_y - 1);
+  GridUGraph::NodeMap<bool> filter(ugraph);
+
+  for (int j = 0; j < height; ++j) {
+    in >> ws;
+    for (int i = 0; i < width; ++i) {
+      char c; in >> c;
+      filter[ugraph(i, j)] = (c == '.');
+    }
+  }
+
+  typedef NodeSubGraphAdaptor<GridUGraph,
+    GridUGraph::NodeMap<bool> > FilteredGraph;
+
+  FilteredGraph filtered(ugraph, filter);
+
+  Bfs<FilteredGraph> bfs(filtered);
+  std::cout << "The length of shortest path: " << 
+    bfs.run(start, stop) << std::endl;
+
+  FilteredGraph::EdgeMap<bool> path(filtered, false);
+  
+  for (GridUGraph::Node node = stop; 
+       node != start; node = bfs.predNode(node)) {
+    path[bfs.predEdge(node)] = true;
+  }
+  
+  graphToEps(filtered, "grid_ugraph_demo.eps").scaleToA4().
+    title("Grid ugraph").
+    copyright("(C) 2006 LEMON Project").
+    coords(scaleMap(indexMap(ugraph), 10)).
+    enableParallel().
+    nodeScale(0.5).
+    drawArrows().
+    edgeColors(composeMap(ColorSet(), path)).
+    run();
+  
+  std::cout << "The shortest path is written to grid_ugraph_demo.eps" 
+	    << std::endl;
+
+  return 0;
+}
Index: demo/grid_ugraph_demo.in
===================================================================
--- demo/grid_ugraph_demo.in	(revision 1979)
+++ demo/grid_ugraph_demo.in	(revision 1979)
@@ -0,0 +1,10 @@
+10 8
+1 1 10 8
+..X....X.X
+.XX.X.XX..
+....X..XX.
+XXXXXX.X..
+.........X
+.X.XXXXXXX
+.X...XX...
+.X.X....X.
Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 1977)
+++ lemon/Makefile.am	(revision 1979)
@@ -41,5 +41,5 @@
 	fredman_tarjan.h \
 	full_graph.h \
-	grid_graph.h \
+	grid_ugraph.h \
 	graph_adaptor.h \
 	graph_utils.h \
@@ -76,4 +76,5 @@
 	topology.h \
 	traits.h \
+	ugraph_adaptor.h \
 	unionfind.h \
 	xy.h \
@@ -88,12 +89,10 @@
 	bits/array_map.h \
 	bits/default_map.h \
+	bits/static_map.h \
 	bits/vector_map.h \
-	bits/iterable_graph_extender.h \
-	bits/extendable_graph_extender.h \
-	bits/clearable_graph_extender.h \
-	bits/erasable_graph_extender.h \
+	bits/map_extender.h \
 	bits/graph_extender.h \
-	bits/map_extender.h \
-	bits/static_map.h \
+	bits/graph_adaptor_extender.h \
+	bits/edge_set_extender.h \
 	bits/item_reader.h \
 	bits/item_writer.h \
Index: lemon/bits/alteration_notifier.h
===================================================================
--- lemon/bits/alteration_notifier.h	(revision 1956)
+++ lemon/bits/alteration_notifier.h	(revision 1979)
@@ -266,6 +266,14 @@
     void add(const Item& item) {
       typename Container::iterator it;
-      for (it = container.begin(); it != container.end(); ++it) {
-	(*it)->add(item);
+      try {
+        for (it = container.begin(); it != container.end(); ++it) {
+          (*it)->add(item);
+        }
+      } catch (...) {
+        typename Container::iterator jt;
+        for (jt = container.begin(); jt != it; ++it) {
+          (*it)->erase(item);
+        }
+        throw;
       }
     }	
@@ -279,6 +287,14 @@
     void add(const std::vector<Item>& items) {
       typename Container::iterator it;
-      for (it = container.begin(); it != container.end(); ++it) {
-	(*it)->add(items);
+      try {
+        for (it = container.begin(); it != container.end(); ++it) {
+          (*it)->add(items);
+        }
+      } catch (...) {
+        typename Container::iterator jt;
+        for (jt = container.begin(); jt != it; ++it) {
+          (*it)->erase(items);
+        }
+        throw;
       }
     }	
@@ -317,6 +333,14 @@
     void build() {
       typename Container::iterator it;
-      for (it = container.begin(); it != container.end(); ++it) {
-	(*it)->build();
+      try {
+        for (it = container.begin(); it != container.end(); ++it) {
+          (*it)->build();
+        }
+      } catch (...) {
+        typename Container::iterator jt;
+        for (jt = container.begin(); jt != it; ++it) {
+          (*it)->clear();
+        }
+        throw;
       }
     }
@@ -336,230 +360,4 @@
   };
 
-
-  /// \brief Class to extend a graph with the functionality of alteration
-  /// observing.
-  ///
-  /// AlterableGraphExtender extends the _Base graphs functionality with
-  /// the possibility of alteration observing. It defines two observer
-  /// registrys for the nodes and mapes.
-  /// 
-  /// \todo Document what "alteration observing" is. And probably find a
-  /// better (shorter) name.
-  ///
-  /// \param _Base is the base class to extend.
-  ///
-  /// \pre _Base is conform to the BaseGraphComponent concept.
-  ///
-  /// \post AlterableGraphExtender<_Base> is conform to the
-  /// AlterableGraphComponent concept.
-  ///
-  /// \author Balazs Dezso
-
-  template <typename _Base> 
-  class AlterableGraphExtender : public _Base {
-  public:
-
-    typedef AlterableGraphExtender Graph;
-    typedef _Base Parent;
-
-    typedef typename Parent::Node Node;
-    typedef typename Parent::Edge Edge;
-
-    /// The edge observer registry.
-    typedef AlterationNotifier<Edge> EdgeNotifier;
-    /// The node observer registry.
-    typedef AlterationNotifier<Node> NodeNotifier;
-
-
-  protected:
-
-    mutable EdgeNotifier edge_notifier;
-
-    mutable NodeNotifier node_notifier;
-
-  public:
-
-    /// \brief Gives back the edge alteration notifier.
-    ///
-    /// Gives back the edge alteration notifier.
-    EdgeNotifier& getNotifier(Edge) const {
-      return edge_notifier;
-    }
-
-    /// \brief Gives back the node alteration notifier.
-    ///
-    /// Gives back the node alteration notifier.
-    NodeNotifier& getNotifier(Node) const {
-      return node_notifier;
-    }
-
-    ~AlterableGraphExtender() {
-      node_notifier.clear();
-      edge_notifier.clear();
-    }
-    
-  };
-
-
-  template <typename _Base> 
-  class AlterableEdgeSetExtender : public _Base {
-  public:
-
-    typedef AlterableEdgeSetExtender Graph;
-    typedef _Base Parent;
-
-    typedef typename Parent::Edge Edge;
-
-    /// The edge observer registry.
-    typedef AlterationNotifier<Edge> EdgeNotifier;
-
-  protected:
-
-    mutable EdgeNotifier edge_notifier;
-
-  public:
-
-    /// \brief Gives back the edge alteration notifier.
-    ///
-    /// Gives back the edge alteration notifier.
-    EdgeNotifier& getNotifier(Edge) const {
-      return edge_notifier;
-    }
-
-    ~AlterableEdgeSetExtender() {
-      edge_notifier.clear();
-    }
-    
-  };
-
-  /// \brief Class to extend an undirected graph with the functionality of
-  /// alteration observing.
-  ///
-  /// \todo Document.
-  ///
-  /// \sa AlterableGraphExtender
-  ///
-  /// \bug This should be done some other way. Possibilities: template
-  /// specialization (not very easy, if at all possible); some kind of
-  /// enable_if boost technique?
-
-  template <typename _Base> 
-  class AlterableUGraphExtender
-    : public AlterableGraphExtender<_Base> {
-  public:
-
-    typedef AlterableUGraphExtender Graph;
-    typedef AlterableGraphExtender<_Base> Parent;
-
-    typedef typename Parent::UEdge UEdge;
-
-    /// The edge observer registry.
-    typedef AlterationNotifier<UEdge> UEdgeNotifier;
-
-  protected:
-
-    mutable UEdgeNotifier u_edge_notifier;
-
-  public:
-
-    using Parent::getNotifier;
-    UEdgeNotifier& getNotifier(UEdge) const {
-      return u_edge_notifier;
-    }
-
-    ~AlterableUGraphExtender() {
-      u_edge_notifier.clear();
-    }
-  };
-
-  template <typename _Base> 
-  class AlterableUEdgeSetExtender
-    : public AlterableEdgeSetExtender<_Base> {
-  public:
-
-    typedef AlterableUEdgeSetExtender Graph;
-    typedef AlterableEdgeSetExtender<_Base> Parent;
-
-    typedef typename Parent::UEdge UEdge;
-
-    typedef AlterationNotifier<UEdge> UEdgeNotifier;
-
-  protected:
-
-    mutable UEdgeNotifier u_edge_notifier;
-
-  public:
-
-    using Parent::getNotifier;
-    UEdgeNotifier& getNotifier(UEdge) const {
-      return u_edge_notifier;
-    }
-
-    ~AlterableUEdgeSetExtender() {
-      u_edge_notifier.clear();
-    }
-  };
-
-
-
-  template <typename _Base>
-  class AlterableBpUGraphExtender : public _Base {
-  public:
-
-    typedef _Base Parent;
-    typedef AlterableBpUGraphExtender Graph;
-  
-    typedef typename Parent::Node Node;
-    typedef typename Parent::BNode BNode;
-    typedef typename Parent::ANode ANode;
-    typedef typename Parent::Edge Edge;
-    typedef typename Parent::UEdge UEdge;
-  
-  
-    typedef AlterationNotifier<Node> NodeNotifier;
-    typedef AlterationNotifier<BNode> BNodeNotifier;
-    typedef AlterationNotifier<ANode> ANodeNotifier;
-    typedef AlterationNotifier<Edge> EdgeNotifier;
-    typedef AlterationNotifier<UEdge> UEdgeNotifier;
-
-  protected:
-
-    mutable NodeNotifier nodeNotifier;
-    mutable BNodeNotifier bNodeNotifier;
-    mutable ANodeNotifier aNodeNotifier;
-    mutable EdgeNotifier edgeNotifier;
-    mutable UEdgeNotifier uEdgeNotifier;
-
-  public:
-
-    NodeNotifier& getNotifier(Node) const {
-      return nodeNotifier;
-    }
-
-    BNodeNotifier& getNotifier(BNode) const {
-      return bNodeNotifier;
-    }
-
-    ANodeNotifier& getNotifier(ANode) const {
-      return aNodeNotifier;
-    }
-
-    EdgeNotifier& getNotifier(Edge) const {
-      return edgeNotifier;
-    }
-
-    UEdgeNotifier& getNotifier(UEdge) const {
-      return uEdgeNotifier;
-    }
-
-    ~AlterableBpUGraphExtender() {
-      nodeNotifier.clear();
-      bNodeNotifier.clear();
-      aNodeNotifier.clear();
-      edgeNotifier.clear();
-      uEdgeNotifier.clear();
-    }
-
-  };
   
 /// @}
Index: lemon/bits/default_map.h
===================================================================
--- lemon/bits/default_map.h	(revision 1966)
+++ lemon/bits/default_map.h	(revision 1979)
@@ -23,4 +23,5 @@
 #include <lemon/bits/array_map.h>
 #include <lemon/bits/vector_map.h>
+#include <lemon/bits/static_map.h>
 
 ///\ingroup graphmapfactory
@@ -31,5 +32,6 @@
 namespace lemon {
   
-#ifndef GLIBCXX_DEBUG
+  
+#ifndef _GLIBCXX_DEBUG
 
   template <typename _Graph, typename _Item, typename _Value>
@@ -168,481 +170,4 @@
   };
 
-
-  /// \e
-  template <typename _Base> 
-  class MappableGraphExtender : public _Base {
-  public:
-
-    typedef MappableGraphExtender<_Base> Graph;
-    typedef _Base Parent;
-
-    typedef typename Parent::Node Node;
-    typedef typename Parent::NodeIt NodeIt;
-
-    typedef typename Parent::Edge Edge;
-    typedef typename Parent::EdgeIt EdgeIt;
-
-    
-    template <typename _Value>
-    class NodeMap 
-      : public IterableMapExtender<DefaultMap<Graph, Node, _Value> > {
-    public:
-      typedef MappableGraphExtender Graph;
-      typedef IterableMapExtender<DefaultMap<Graph, Node, _Value> > Parent;
-
-      NodeMap(const Graph& _g) 
-	: Parent(_g) {}
-      NodeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-
-      NodeMap& operator=(const NodeMap& cmap) {
-	return operator=<NodeMap>(cmap);
-      }
-
-
-      /// \brief Template assign operator.
-      ///
-      /// The given parameter should be conform to the ReadMap
-      /// concecpt and could be indiced by the current item set of
-      /// the NodeMap. In this case the value for each item
-      /// is assigned by the value of the given ReadMap. 
-      template <typename CMap>
-      NodeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<Node, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	Node it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-
-    };
-
-    template <typename _Value>
-    class EdgeMap 
-      : public IterableMapExtender<DefaultMap<Graph, Edge, _Value> > {
-    public:
-      typedef MappableGraphExtender Graph;
-      typedef IterableMapExtender<DefaultMap<Graph, Edge, _Value> > Parent;
-
-      EdgeMap(const Graph& _g) 
-	: Parent(_g) {}
-      EdgeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-
-      EdgeMap& operator=(const EdgeMap& cmap) {
-	return operator=<EdgeMap>(cmap);
-      }
-
-      template <typename CMap>
-      EdgeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<Edge, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	Edge it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    };
-    
-  };
-
-  /// \e
-  template <typename _Base> 
-  class MappableEdgeSetExtender : public _Base {
-  public:
-
-    typedef MappableEdgeSetExtender<_Base> Graph;
-    typedef _Base Parent;
-
-    typedef typename Parent::Edge Edge;
-    typedef typename Parent::EdgeIt EdgeIt;
-
-    template <typename _Value>
-    class EdgeMap 
-      : public IterableMapExtender<DefaultMap<Graph, Edge, _Value> > {
-    public:
-      typedef MappableEdgeSetExtender Graph;
-      typedef IterableMapExtender<DefaultMap<Graph, Edge, _Value> > Parent;
-
-      EdgeMap(const Graph& _g) 
-	: Parent(_g) {}
-      EdgeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-
-      EdgeMap& operator=(const EdgeMap& cmap) {
-	return operator=<EdgeMap>(cmap);
-      }
-
-      template <typename CMap>
-      EdgeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<Edge, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	Edge it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    };
-    
-  };
-
-  /// \e
-  template <typename _Base> 
-  class MappableUGraphExtender : 
-    public MappableGraphExtender<_Base> {
-  public:
-
-    typedef MappableUGraphExtender Graph;
-    typedef MappableGraphExtender<_Base> Parent;
-
-    typedef typename Parent::UEdge UEdge;
-
-    template <typename _Value>
-    class UEdgeMap 
-      : public IterableMapExtender<DefaultMap<Graph, UEdge, _Value> > {
-    public:
-      typedef MappableUGraphExtender Graph;
-      typedef IterableMapExtender<
-	DefaultMap<Graph, UEdge, _Value> > Parent;
-
-      UEdgeMap(const Graph& _g) 
-	: Parent(_g) {}
-      UEdgeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-
-      UEdgeMap& operator=(const UEdgeMap& cmap) {
-	return operator=<UEdgeMap>(cmap);
-      }
-
-      template <typename CMap>
-      UEdgeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<UEdge, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	UEdge it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    };
-
-
-  };
-
-  /// \e
-  template <typename _Base> 
-  class MappableUEdgeSetExtender : 
-    public MappableEdgeSetExtender<_Base> {
-  public:
-
-    typedef MappableUEdgeSetExtender Graph;
-    typedef MappableEdgeSetExtender<_Base> Parent;
-
-    typedef typename Parent::UEdge UEdge;
-
-    template <typename _Value>
-    class UEdgeMap 
-      : public IterableMapExtender<DefaultMap<Graph, UEdge, _Value> > {
-    public:
-      typedef MappableUEdgeSetExtender Graph;
-      typedef IterableMapExtender<
-	DefaultMap<Graph, UEdge, _Value> > Parent;
-
-      UEdgeMap(const Graph& _g) 
-	: Parent(_g) {}
-      UEdgeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-
-      UEdgeMap& operator=(const UEdgeMap& cmap) {
-	return operator=<UEdgeMap>(cmap);
-      }
-
-      template <typename CMap>
-      UEdgeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<UEdge, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	UEdge it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    };
-
-
-  };
-
-
-  template <typename _Base>
-  class MappableBpUGraphExtender : public _Base {
-  public:
-
-    typedef _Base Parent;
-    typedef MappableBpUGraphExtender Graph;
-
-    typedef typename Parent::Node Node;
-    typedef typename Parent::ANode ANode;
-    typedef typename Parent::BNode BNode;
-    typedef typename Parent::Edge Edge;
-    typedef typename Parent::UEdge UEdge;
-    
-    template <typename _Value>
-    class ANodeMap 
-      : public IterableMapExtender<DefaultMap<Graph, ANode, _Value> > {
-    public:
-      typedef MappableBpUGraphExtender Graph;
-      typedef IterableMapExtender<DefaultMap<Graph, ANode, _Value> > 
-      Parent;
-    
-      ANodeMap(const Graph& _g) 
-	: Parent(_g) {}
-      ANodeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-    
-      ANodeMap& operator=(const ANodeMap& cmap) {
-	return operator=<ANodeMap>(cmap);
-      }
-    
-
-      /// \brief Template assign operator.
-      ///
-      /// The given parameter should be conform to the ReadMap
-      /// concept and could be indiced by the current item set of
-      /// the ANodeMap. In this case the value for each item
-      /// is assigned by the value of the given ReadMap. 
-      template <typename CMap>
-      ANodeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<ANode, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	ANode it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    
-    };
-
-    template <typename _Value>
-    class BNodeMap 
-      : public IterableMapExtender<DefaultMap<Graph, BNode, _Value> > {
-    public:
-      typedef MappableBpUGraphExtender Graph;
-      typedef IterableMapExtender<DefaultMap<Graph, BNode, _Value> > 
-      Parent;
-    
-      BNodeMap(const Graph& _g) 
-	: Parent(_g) {}
-      BNodeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-    
-      BNodeMap& operator=(const BNodeMap& cmap) {
-	return operator=<BNodeMap>(cmap);
-      }
-    
-
-      /// \brief Template assign operator.
-      ///
-      /// The given parameter should be conform to the ReadMap
-      /// concept and could be indiced by the current item set of
-      /// the BNodeMap. In this case the value for each item
-      /// is assigned by the value of the given ReadMap. 
-      template <typename CMap>
-      BNodeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<BNode, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	BNode it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    
-    };
-
-  protected:
-
-    template <typename _Value>
-    class NodeMapBase : public Parent::NodeNotifier::ObserverBase {
-    public:
-      typedef MappableBpUGraphExtender Graph;
-
-      typedef Node Key;
-      typedef _Value Value;
-
-      /// The reference type of the map;
-      typedef typename BNodeMap<_Value>::Reference Reference;
-      /// The pointer type of the map;
-      typedef typename BNodeMap<_Value>::Pointer Pointer;
-      
-      /// The const value type of the map.
-      typedef const Value ConstValue;
-      /// The const reference type of the map;
-      typedef typename BNodeMap<_Value>::ConstReference ConstReference;
-      /// The pointer type of the map;
-      typedef typename BNodeMap<_Value>::ConstPointer ConstPointer;
-
-      typedef True ReferenceMapTag;
-
-      NodeMapBase(const Graph& _g) 
-	: graph(&_g), bNodeMap(_g), aNodeMap(_g) {
-	Parent::NodeNotifier::ObserverBase::attach(_g.getNotifier(Node()));
-      }
-      NodeMapBase(const Graph& _g, const _Value& _v) 
-	: graph(&_g), bNodeMap(_g, _v), 
-	  aNodeMap(_g, _v) {
-	Parent::NodeNotifier::ObserverBase::attach(_g.getNotifier(Node()));
-      }
-
-      virtual ~NodeMapBase() {      
-	if (Parent::NodeNotifier::ObserverBase::attached()) {
-	  Parent::NodeNotifier::ObserverBase::detach();
-	}
-      }
-    
-      ConstReference operator[](const Key& node) const {
-	if (Parent::aNode(node)) {
-	  return aNodeMap[node];
-	} else {
-	  return bNodeMap[node];
-	}
-      } 
-
-      Reference operator[](const Key& node) {
-	if (Parent::aNode(node)) {
-	  return aNodeMap[node];
-	} else {
-	  return bNodeMap[node];
-	}
-      }
-
-      void set(const Key& node, const Value& value) {
-	if (Parent::aNode(node)) {
-	  aNodeMap.set(node, value);
-	} else {
-	  bNodeMap.set(node, value);
-	}
-      }
-
-    protected:
-      
-      virtual void add(const Node&) {}
-      virtual void add(const std::vector<Node>&) {}
-      virtual void erase(const Node&) {}
-      virtual void erase(const std::vector<Node>&) {}
-      virtual void clear() {}
-      virtual void build() {}
-
-      const Graph* getGraph() const { return graph; }
-      
-    private:
-      const Graph* graph;
-      BNodeMap<_Value> bNodeMap;
-      ANodeMap<_Value> aNodeMap;
-    };
-    
-  public:
-
-    template <typename _Value>
-    class NodeMap 
-      : public IterableMapExtender<NodeMapBase<_Value> > {
-    public:
-      typedef MappableBpUGraphExtender Graph;
-      typedef IterableMapExtender< NodeMapBase<_Value> > Parent;
-    
-      NodeMap(const Graph& _g) 
-	: Parent(_g) {}
-      NodeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-    
-      NodeMap& operator=(const NodeMap& cmap) {
-	return operator=<NodeMap>(cmap);
-      }
-    
-
-      /// \brief Template assign operator.
-      ///
-      /// The given parameter should be conform to the ReadMap
-      /// concept and could be indiced by the current item set of
-      /// the NodeMap. In this case the value for each item
-      /// is assigned by the value of the given ReadMap. 
-      template <typename CMap>
-      NodeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<Node, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	Node it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    
-    };
-
-
-
-    template <typename _Value>
-    class EdgeMap 
-      : public IterableMapExtender<DefaultMap<Graph, Edge, _Value> > {
-    public:
-      typedef MappableBpUGraphExtender Graph;
-      typedef IterableMapExtender<DefaultMap<Graph, Edge, _Value> > Parent;
-    
-      EdgeMap(const Graph& _g) 
-	: Parent(_g) {}
-      EdgeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-    
-      EdgeMap& operator=(const EdgeMap& cmap) {
-	return operator=<EdgeMap>(cmap);
-      }
-    
-      template <typename CMap>
-      EdgeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<Edge, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	Edge it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    };
-
-    template <typename _Value>
-    class UEdgeMap 
-      : public IterableMapExtender<DefaultMap<Graph, UEdge, _Value> > {
-    public:
-      typedef MappableBpUGraphExtender Graph;
-      typedef IterableMapExtender<DefaultMap<Graph, UEdge, _Value> > 
-      Parent;
-    
-      UEdgeMap(const Graph& _g) 
-	: Parent(_g) {}
-      UEdgeMap(const Graph& _g, const _Value& _v) 
-	: Parent(_g, _v) {}
-    
-      UEdgeMap& operator=(const UEdgeMap& cmap) {
-	return operator=<UEdgeMap>(cmap);
-      }
-    
-      template <typename CMap>
-      UEdgeMap& operator=(const CMap& cmap) {
-	checkConcept<concept::ReadMap<UEdge, _Value>, CMap>();
-	const typename Parent::Graph* graph = Parent::getGraph();
-	UEdge it;
-	for (graph->first(it); it != INVALID; graph->next(it)) {
-	  Parent::set(it, cmap[it]);
-	}
-	return *this;
-      }
-    };
-  
-  };
-
 }
 
